﻿Public Class Form1
    Private intVersuche As Integer      ' summe aller versuche
    Private intKlicks As Integer        ' klicks auf bilder zaehlen
    Private intAuswahl(2) As Integer    ' gewaehlte bilder in Form1
    Private Const strSPIELANLEITUNG = "sp_flaggen.pdf"
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        ' bilder auf dem spielfeld
        ZeichneBilder.Add(Pic0) : ZeichneBilder.Add(Pic1) : ZeichneBilder.Add(Pic2) : ZeichneBilder.Add(Pic3)
        ZeichneBilder.Add(Pic4) : ZeichneBilder.Add(Pic5) : ZeichneBilder.Add(Pic6) : ZeichneBilder.Add(Pic7)
        ZeichneBilder.Add(Pic8) : ZeichneBilder.Add(Pic9) : ZeichneBilder.Add(Pic10) : ZeichneBilder.Add(Pic11)
        ZeichneBilder.Add(Pic12) : ZeichneBilder.Add(Pic13) : ZeichneBilder.Add(Pic14) : ZeichneBilder.Add(Pic15)
        ZeichneBilder.Add(Pic16) : ZeichneBilder.Add(Pic17) : ZeichneBilder.Add(Pic18) : ZeichneBilder.Add(Pic19)    '   000
        ZeichneBilder.Add(Pic20) : ZeichneBilder.Add(Pic21) : ZeichneBilder.Add(Pic22) : ZeichneBilder.Add(Pic23)    '   000
        ' bilder der frmFlaggen
        BildNr.Add(FrmFlaggen.PicFlagge0) : BildNr.Add(FrmFlaggen.PicFlagge1) : BildNr.Add(FrmFlaggen.PicFlagge2)
        BildNr.Add(FrmFlaggen.PicFlagge3) : BildNr.Add(FrmFlaggen.PicFlagge4) : BildNr.Add(FrmFlaggen.PicFlagge5)
        BildNr.Add(FrmFlaggen.PicFlagge6) : BildNr.Add(FrmFlaggen.PicFlagge7) : BildNr.Add(FrmFlaggen.PicFlagge8)
        BildNr.Add(FrmFlaggen.PicFlagge9) : BildNr.Add(FrmFlaggen.PicFlagge10) : BildNr.Add(FrmFlaggen.PicFlagge11)
        BildNr.Add(FrmFlaggen.PicFlagge12)
        ' beschriftung
        CmdEnde.Text = "B&eenden" : CmdHilfe.Text = "&Spielanleitung" : CmdVorschau.Text = "&Vorschau"
        CmdNeu.Text = "&Neues Spiel" : Me.Text = "Flaggenspiel" : LblVersuche.Text = "0"
        StarteSpiel()              '-- posiionen festlegen
        'ZeichneGrueneFelder()      '-- bilder verbergen
    End Sub

    Private Sub CmdEnde_Click(sender As Object, e As EventArgs) Handles CmdEnde.Click
        BeendeDasSpiel()
    End Sub
    Private Sub BeendeDasSpiel()
        Dim strMeldung As String = "Bist Du sicher," _
                   & vbCrLf & "dass Du das Spiel beenden möchtest?"
        Dim strTitel As String = "Spiel beenden"
        Dim buttons As MessageBoxButtons = MessageBoxButtons.YesNo
        Dim DefaultButton As MessageBoxDefaultButton = MessageBoxDefaultButton.Button2
        Dim Icon As MessageBoxIcon = MessageBoxIcon.Question
        Dim intResultat As DialogResult
        intResultat = MessageBox.Show(strMeldung, strTitel, buttons, Icon, DefaultButton)
        '-- reaktion
        If (intResultat = DialogResult.Yes) Then
            Close()
        End If
    End Sub
    Private Sub KlickAuswerten(intPosition As Integer)
        CmdVorschau.Enabled = False
        MnuVorschau.Enabled = False   '  000
        intKlicks += 1    ' klicks zaehlen
        intAuswahl(intKlicks) = intPosition
        ZeichneBilder(intPosition).Image =
            BildNr(intBildFeldPosition(intPosition)).Image
        LblInfo.Text = "Klicke auf ein weiteres grünes Feld."
        If intKlicks = 2 Then
            SperreKlicks() ' kein weiterer klick -modFlaggen-
            If intBildFeldPosition(intAuswahl(1)) =
                intBildFeldPosition(intAuswahl(2)) Then
                LblInfo.Text = "Übereinstimmung:" & vbCrLf &
                    "Die Flaggen sind identisch."
                Timer2.Interval = 500
                Timer2.Start()
                '         000 hinzugefügt
                If MnuSoundAn.Checked Then
                    Try
                        My.Computer.Audio.Play("TADA.WAV",
                             AudioPlayMode.Background)
                    Catch ex As Exception
                        ' keine aktion
                    End Try
                End If
            Else
                LblInfo.Text = "Keine Übereinstimmung:" & vbCrLf &
                    "Merke Dir die Positionen der Flaggen."
                Timer1.Interval = 2000   'Timer1.Interval = 3000
                Timer1.Start()
            End If
        End If
    End Sub

    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        Timer1.Stop()
        ZeichneGrueneFelder()
        AuswertungBilder()      ' gruen einfaerben
    End Sub
    Private Sub Timer2_Tick(sender As Object, e As EventArgs) Handles Timer2.Tick
        Timer2.Stop()
        ZeichneBilder(intAuswahl(1)).Visible = False
        ZeichneBilder(intAuswahl(2)).Visible = False
        ProbeEnde()  ' spiel beendet?
        Timer1.Stop()
    End Sub

    Private Sub Timer3_Tick(sender As Object, e As EventArgs) Handles Timer3.Tick
        Timer3.Stop()
        ZeichneGrueneFelder()
        GibKlicksFrei()
        LblInfo.Text = "Klicke auf ein grünes Feld," & vbCrLf &
                 "um eine Flagge aufzudecken."
    End Sub
    Private Sub Pic0_Click(sender As Object, e As EventArgs) Handles Pic0.Click
        If booGesperrt(0) = True Then Exit Sub
        booGesperrt(0) = True
        KlickAuswerten(0)
    End Sub
    Private Sub Pic1_Click(sender As Object, e As EventArgs) Handles Pic1.Click
        If booGesperrt(1) = True Then Exit Sub
        booGesperrt(1) = True
        KlickAuswerten(1)
    End Sub

    Private Sub Pic2_Click(sender As Object, e As EventArgs) Handles Pic2.Click
        If booGesperrt(2) = True Then Exit Sub
        booGesperrt(2) = True
        KlickAuswerten(2)
    End Sub

    Private Sub Pic3_Click(sender As Object, e As EventArgs) Handles Pic3.Click
        If booGesperrt(3) = True Then Exit Sub
        booGesperrt(3) = True
        KlickAuswerten(3)
    End Sub

    Private Sub Pic4_Click(sender As Object, e As EventArgs) Handles Pic4.Click
        If booGesperrt(4) = True Then Exit Sub
        booGesperrt(4) = True
        KlickAuswerten(4)
    End Sub

    Private Sub Pic5_Click(sender As Object, e As EventArgs) Handles Pic5.Click
        If booGesperrt(5) = True Then Exit Sub
        booGesperrt(5) = True
        KlickAuswerten(5)
    End Sub

    Private Sub Pic6_Click(sender As Object, e As EventArgs) Handles Pic6.Click
        If booGesperrt(6) = True Then Exit Sub
        booGesperrt(6) = True
        KlickAuswerten(6)
    End Sub

    Private Sub Pic7_Click(sender As Object, e As EventArgs) Handles Pic7.Click
        If booGesperrt(7) = True Then Exit Sub
        booGesperrt(7) = True
        KlickAuswerten(7)
    End Sub

    Private Sub Pic8_Click(sender As Object, e As EventArgs) Handles Pic8.Click
        If booGesperrt(8) = True Then Exit Sub
        booGesperrt(8) = True
        KlickAuswerten(8)
    End Sub

    Private Sub Pic9_Click(sender As Object, e As EventArgs) Handles Pic9.Click
        If booGesperrt(9) = True Then Exit Sub
        booGesperrt(9) = True
        KlickAuswerten(9)
    End Sub

    Private Sub Pic10_Click(sender As Object, e As EventArgs) Handles Pic10.Click
        If booGesperrt(10) = True Then Exit Sub
        booGesperrt(10) = True
        KlickAuswerten(10)
    End Sub

    Private Sub Pic11_Click(sender As Object, e As EventArgs) Handles Pic11.Click
        If booGesperrt(11) = True Then Exit Sub
        booGesperrt(11) = True
        KlickAuswerten(11)
    End Sub

    Private Sub Pic12_Click(sender As Object, e As EventArgs) Handles Pic12.Click
        If booGesperrt(12) = True Then Exit Sub
        booGesperrt(12) = True
        KlickAuswerten(12)
    End Sub

    Private Sub Pic13_Click(sender As Object, e As EventArgs) Handles Pic13.Click
        If booGesperrt(13) = True Then Exit Sub
        booGesperrt(13) = True
        KlickAuswerten(13)
    End Sub

    Private Sub Pic14_Click(sender As Object, e As EventArgs) Handles Pic14.Click
        If booGesperrt(14) = True Then Exit Sub
        booGesperrt(14) = True
        KlickAuswerten(14)
    End Sub

    Private Sub Pic15_Click(sender As Object, e As EventArgs) Handles Pic15.Click
        If booGesperrt(15) = True Then Exit Sub
        booGesperrt(15) = True
        KlickAuswerten(15)
    End Sub
    '----------------

    Private Sub AuswertungBilder()
        intKlicks = 0
        intVersuche += 1   ' versuche zaehlen
        GibKlicksFrei()    ' klicks moeglich -modFlaggen-
        LblVersuche.Text = intVersuche.ToString
        LblInfo.Text = "Klicke auf ein grünes Feld," & vbCrLf &
            "um eine Flagge aufzudecken."
    End Sub

    Private Sub ProbeEnde()
        Dim intAnzahl As Integer = 0
        Dim i As Integer
        For i = 0 To 23                               '   000
            ' falls das bildfelder verborgen ist
            If Not ZeichneBilder(i).Visible Then intAnzahl += 1
        Next
        If intAnzahl >= 24 Then                             '   000
            MessageBox.Show("Du hast " & intVersuche.ToString &
                            " Versuche benötigt!", "Flaggenspiel")
            CmdNeu.Enabled = True
            LblInfo.Text = "Klicke auf >Neues Spiel<," & vbCrLf &
                "falls Du noch einmal spielen möchtest."
        Else
            AuswertungBilder()
        End If
    End Sub
    Private Sub CmdVorschau_Click(sender As Object, e As EventArgs) Handles CmdVorschau.Click
        ZeigeVorschau()           '  000
    End Sub
    'End Sub
    Private Sub ZeigeVorschau()
        '   000 neu hinzugefügt
        LblInfo.Text = "Die Vorschau ist aktiv."
        CmdVorschau.Enabled = False
        MnuVorschau.Enabled = False    '   000
        SperreKlicks()
        Vorschau()
        Timer3.Interval = 3000
        Timer3.Start()
    End Sub
    Private Sub CmdNeu_Click(sender As Object, e As EventArgs) Handles CmdNeu.Click
        StarteEinNeuesSpiel()     '   000
    End Sub
    Private Sub StarteEinNeuesSpiel()
        '   000 neu hinzugefügt
        StarteSpiel()
        ZeichneGrueneFelder()
        CmdVorschau.Enabled = True
        MnuVorschau.Enabled = True
        intVersuche = 0
        LblVersuche.Text = "0"
        intKlicks = 0
    End Sub
    '       000      klick auf neue Bildfelder 16 - 23
    Private Sub Pic16_Click(sender As Object, e As EventArgs) Handles Pic16.Click
        If booGesperrt(16) = True Then Exit Sub
        booGesperrt(16) = True
        KlickAuswerten(16)
    End Sub

    Private Sub Pic17_Click(sender As Object, e As EventArgs) Handles Pic17.Click
        If booGesperrt(17) = True Then Exit Sub
        booGesperrt(17) = True
        KlickAuswerten(17)
    End Sub

    Private Sub Pic18_Click(sender As Object, e As EventArgs) Handles Pic18.Click
        If booGesperrt(18) = True Then Exit Sub
        booGesperrt(18) = True
        KlickAuswerten(18)
    End Sub

    Private Sub Pic19_Click(sender As Object, e As EventArgs) Handles Pic19.Click
        If booGesperrt(19) = True Then Exit Sub
        booGesperrt(19) = True
        KlickAuswerten(19)
    End Sub

    Private Sub Pic20_Click(sender As Object, e As EventArgs) Handles Pic20.Click
        If booGesperrt(20) = True Then Exit Sub
        booGesperrt(20) = True
        KlickAuswerten(20)
    End Sub

    Private Sub Pic21_Click(sender As Object, e As EventArgs) Handles Pic21.Click
        If booGesperrt(21) = True Then Exit Sub
        booGesperrt(21) = True
        KlickAuswerten(21)
    End Sub

    Private Sub Pic22_Click(sender As Object, e As EventArgs) Handles Pic22.Click
        If booGesperrt(22) = True Then Exit Sub
        booGesperrt(22) = True
        KlickAuswerten(22)
    End Sub

    Private Sub Pic23_Click(sender As Object, e As EventArgs) Handles Pic23.Click
        If booGesperrt(23) = True Then Exit Sub
        booGesperrt(23) = True
        KlickAuswerten(23)
    End Sub

    Private Sub MnuVorschau_Click(sender As Object, e As EventArgs) Handles MnuVorschau.Click
        ZeigeVorschau()          '  000
    End Sub
    Private Sub SoundEinstellungen()
        '   000
        If MnuSoundAn.Checked Then
            MnuSoundAn.Checked = False : MnuSoundAus.Checked = True
        Else
            MnuSoundAn.Checked = True : MnuSoundAus.Checked = False
        End If
    End Sub

    Private Sub CmdHilfe_Click(sender As Object, e As EventArgs) Handles CmdHilfe.Click
        ZeigeSpielAnleitung()      '   000
    End Sub
    Private Sub ZeigeSpielAnleitung()
        '   000 neu eingefügt
        Try
            Process.Start(System.IO.Path.Combine(
                  Application.StartupPath,
                  strSPIELANLEITUNG))
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub
    Private Sub Form1_KeyDown(sender As Object, e As KeyEventArgs) Handles MyBase.KeyDown
        If e.KeyCode = Keys.F1 Then
            ZeigeSpielAnleitung()
        End If
    End Sub

    Private Sub MnuSoundAn_Click(sender As Object, e As EventArgs) Handles MnuSoundAn.Click
        SoundEinstellungen()
    End Sub
    Private Sub MnuSoundAus_Click(sender As Object, e As EventArgs) Handles MnuSoundAus.Click
        SoundEinstellungen()
    End Sub

    Private Sub MnuSpielAnleitung_Click(sender As Object, e As EventArgs) Handles MnuSpielAnleitung.Click
        ZeigeSpielAnleitung()
    End Sub
End Class
